module Main where

import Prelude hiding (append)

import DOM.Simple.Console (log2)
import Effect (Effect)
import Math

import Graphics.D3.Base
import Graphics.D3.Scale
import Graphics.D3.Selection

main :: Effect Unit
main = do
  log2 "d3" d3
  scale <- linearScale
    >>= domain [-10.0, 10.0]
    >>= range [0.0, 1.0]
    >>= toFunction
  log2 "after scaleLinear" scale
  log2 "scale @ 5" $ scale 5.0
  selected <- rootSelect "#select-me"
  log2 "selected '#select-me'" selected
  let data' = [ "first data", "second data" ]
  simpleData <- rootSelect "#simple-data"
    >>= selectAll "p"
    >>= bindData data'
    >>= text' show
  log2 "simpleData" simpleData
  dataWithAppend <- rootSelect "#data-with-append"
    >>= selectAll "p"
    >>= bindData data'
    >>= enter
    >>= append "p"
    >>= style'' "color" (\d idx -> if idx `remainder` 2.0 == 0.0 then "green" else "red")
    >>= text' show
  log2 "dataWithAppend" dataWithAppend
